package com.sun.ejb31.test;

import java.util.Date;
import java.util.concurrent.Future;
import javax.ejb.AsyncResult;
import javax.ejb.Stateless;
import javax.ejb.Asynchronous;

@Stateless
public class HelloASyncBean implements HelloAsyncable{

    public void someVoidMethod() {
        
    }
    
    @Asynchronous
    public Future<String> sayHello(int val) {
        Date dt1 = new Date();
        try { Thread.sleep(5*1000); } catch (Exception ex) {}
        Date dt2 = new Date();
        return new AsyncResult<String>("Asynchronous foo got: " + val);
    }
    
    @Asynchronous
    public Future<Double> divide(int p, int q)
        throws Exception {
        if (q == 0) {
            throw new Exception();
        }
        return new AsyncResult<Double>(new Double((1.0* p)/q));
    }
    
}
